package org.saev.deob.trans;

import org.saev.deob.*;
import java.util.*;
import org.apache.bcel.classfile.*;
import org.apache.bcel.generic.*;
import org.apache.bcel.util.*;

public class ExceptionDeleter extends ApplicationTransformer {
	
	public ExceptionDeleter() {
		super();
	}
	
	public Method internalTransform(MethodGen mg) {
		InstructionList il = mg.getInstructionList();
		InstructionFinder f = new InstructionFinder(il);
		String pat = "ASTORE NEW DUP (PushInstruction InvokeInstruction)+ InvokeInstruction+ NEW DUP INVOKESPECIAL ATHROW";
		CodeExceptionGen[] ceg = mg.getExceptionHandlers();
		
		for(Iterator<InstructionHandle[]> it = f.search(pat); it.hasNext(); ) {
			InstructionHandle[] match = it.next();
			InstructionHandle first = match[0];
			InstructionHandle last = match[match.length - 1];
			InstructionHandle next = last.getNext();
			
			for(int i = 0; i < ceg.length; i++) {
				
				if(ceg[i].getHandlerPC().equals(first)) {
					mg.removeExceptionHandler(ceg[i]);
				}
			}
			
			try {
				il.delete(first, last);
			} catch(TargetLostException e) {
				InstructionHandle[] targets = e.getTargets();
				
				if(last == il.getEnd()) {
					next = first.getPrev();
				}
				
				for(int j = 0; j < targets.length; j++) {
					InstructionTargeter[] targeters = targets[j].getTargeters();
					
					for(int k = 0; k < targeters.length; k++) {
						targeters[k].updateTarget(targets[j], next);
					}
				}
			}
		}
		il.setPositions(true);
		InstructionHandle end = il.getEnd();
		InstructionHandle prev = end.getPrev();
		
		if(prev != null && end.getInstruction() instanceof RETURN && prev.getInstruction() instanceof RETURN) {
			
			try {
				il.delete(prev);
			} catch(TargetLostException e) {
				InstructionHandle[] targets = e.getTargets();
				
				for(int j = 0; j < targets.length; j++) {
					InstructionTargeter[] targeters = targets[j].getTargeters();
					
					for(int k = 0; k < targeters.length; k++) {
						targeters[k].updateTarget(targets[j], end);
					}
				}
			}
		}
		mg.setInstructionList(il);
		mg.setMaxLocals();
		mg.setMaxStack();
		return mg.getMethod();
	}

	public String getDescription() {
		return "this is a cheap way of getting the rs clients to\n" +
			"\tcompile correctly by removing most of the error reporting\n" +
			"\texceptions to correct the exit flow.";
	}

	public String getAuthor() {
		return "saevion <saevion at gmail dot com>";
	}

	public String getName() {
		return "rmexcept";
	}
}
